## openvpn3-client 24+dfsg

=== meson_options.txt ===
#  OpenVPN 3 Linux - Next generation OpenVPN
#
#  SPDX-License-Identifier: AGPL-3.0-only
#
#  Copyright (C)  OpenVPN Inc <sales@openvpn.net>
#  Copyright (C)  David Sommerseth <davids@openvpn.net>

#
#  Various debugging features
#
option('debug_disable_security_checks', type: 'boolean', value: false,
       description: 'Disables some security checks restricting D-Bus service access')

option('debug_exceptions', type: 'boolean', value: false,
       description: 'Add additional debug information in C++ exceptions')

option('debug_core_events', type: 'boolean', value: false,
       description: 'Enable logging OpenVPN 3 Core library events')

option('debug_netcfg_netlink', type: 'boolean', value: false,
       description: 'Enabled logging low-level NETLINK debugging in openvpn3-service-netcfg')

option('debug_options', type: 'boolean', value: false,
       description: 'Add additional command line options used for debugging')

#
#  Build environment and related build time options
#
option('asio_path', type: 'string', value: './vendor/asio/asio',
       description: 'Path to the ASIO header files')

option('openvpn3_core_path', type: 'string', value: './openvpn3-core',
       description: 'Path to the OpenVPN 3 Core Library header files')

option('openvpn3_core_version', type: 'string', value: '',
       description: 'Override OpenVPN 3 Core Library version string (for packaging)')

option('doxygen', type: 'feature', value: 'disabled',
       description: 'Build Doxygen documentation')

option('generate-man', type: 'feature', value: 'auto',
       description: 'Build man pages')

option('selinux', type: 'feature', value: 'enabled',
       description: 'Add SELinux support (openvpn3-admin init-config)')

option('selinux_policy', type: 'feature', value: 'auto',
       description: 'Build the OpenVPN 3 Linux SELinux policies')

option('selinux_devel_path', type: 'string', value: '',
       description: 'Override default SELinux path to the Makfile for policy building')

option('docdir', type: 'string', value: '',
       description: 'Override install path for documentation')

#
#  Various runtime defaults
#
option('openvpn_username', type: 'string', value: 'openvpn',
       description: 'Default OpenVPN username owning processes and files')

option('openvpn_group', type: 'string', value: 'openvpn',
       description: 'Default OpenVPN group name owning processes and files')

option('openvpn3_statedir', type: 'string', value: '',
       description: 'Override OpenVPN 3 Linux state directory')

option('devposture_profiledir', type: 'string', value: '',
       description: 'Override OpenVPN 3 Device Posture Protocol Profiles directory')

option('polkit_rulesdir', type: 'string', value: '',
       description: 'Override polkit rules directory')

#
#  OpenVPN 3 Linux features
#
option('addon-aws', type: 'feature', value: 'disabled',
       description: 'Enable the OpenVPN 3 AWS-VPC integration service')

option('addon-deviceposture', type: 'feature', value: 'disabled',
       description: 'Enable the OpenVPN 3 Device Posture service')

option('bash-completion', type: 'feature', value: 'disabled',
       description: 'Build the bash-completion helper scripts')

option('dco', type: 'feature', value: 'enabled',
       description: 'Enable the Data Channel Offload support (DCO)')

#  This is required on distributions using older polkit releases
#  without JavaScript support
option('use-legacy-polkit-pkla', type: 'feature', value: 'disabled',
       description: 'Installs the legacy PKLA based polkit policy files')
option('polkit_pkla_rulesdir', type: 'string', value: '',
       description: 'Override PolicyKit PKLA rules directory')

#
# Installation
#
option('dbus_policy_dir', type: 'string',
       description: 'Override D-Bus policy directory')
option('dbus_system_service_dir', type: 'string',
       description: 'Override D-Bus system service directory')
option('systemd_system_unit_dir', type: 'string',
       description: 'Override path to systemd system unit directory')
option('create_statedir', type: 'boolean', value: 'true',
       description: 'Create directory for OpenVPN 3 state during install phase')

#
#  Testing tools
#
option('unit_tests', type: 'feature', value: 'enabled',
       description: 'Build the unit-test suite')

option('test_programs', type: 'feature', value: 'enabled',
       description: 'Build various test programs in src/tests')

=== openvpn3-core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13...3.28)

project(OpenVPN3-core VERSION 3)

# AddressSanitize - use CXX=clang++ CC=clang cmake -DCMAKE_BUILD_TYPE=asan to build with ASAN
# export  UBSAN_OPTIONS=print_stacktrace=1 helps debugging these
set(CMAKE_C_FLAGS_ASAN
        "-fsanitize=address,undefined -fno-sanitize-recover=all -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1"
        CACHE STRING "Flags used by the C compiler during AddressSanitizer builds."
        FORCE)
set(CMAKE_CXX_FLAGS_ASAN
        "-fsanitize=address,undefined -fno-sanitize-recover=all -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1"
        CACHE STRING "Flags used by the C++ compiler during AddressSanitizer builds."
        FORCE)

set(CMAKE_LINKER_FLAGS_ASAN
        "-fsanitize=address,undefined -fno-sanitize-recover=all -fsanitize-address-use-after-scope"
        CACHE STRING "Flags used by the linker during AddressSanitizer builds."
        FORCE)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake
                      ${CMAKE_MODULE_PATH})
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_C_STANDARD 99)

include(CTest)

include(findcoredeps)
include(ovpn-doxygen)

add_subdirectory(client)
add_subdirectory(test/unittests)
add_subdirectory(test/ovpncli)

add_subdirectory(openvpn/omi)
add_subdirectory(openvpn/ovpnagent/win)
add_subdirectory(openvpn/ovpnagent/mac)

if (ENABLE_DOXYGEN)
    # Exclude some project specific directories
    set(DOXYGEN_EXCLUDE_PATTERNS
        "*/vcpkg_installed/*"
        "*/googletest-src/*"
        "${PROJECT_SOURCE_DIR}/deps/*")

    # Use README.rst as the Doxygen main page
    # Due to some doxygen oddities, it rejects processing README.rst, but a .md file is fine
    # So we copy it into our build tree as a .md file and use that
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/README.rst"
        "${CMAKE_CURRENT_BINARY_DIR}/doxygen/mainpage.md"
        COPYONLY)
    set(DOXYGEN_USE_MDFILE_AS_MAINPAGE "${CMAKE_CURRENT_BINARY_DIR}/doxygen/mainpage.md")

    configure_doxygen("OpenVPN 3 Core Library" "doxygen/core")
endif ()

=== contrib/cmake-clion/CMakeLists.txt ===
#  SPDX-License-Identifier: AGPL-3.0-only
#
#  Copyright (C) 2019 - 2023  OpenVPN Inc <sales@openvpn.net>
#  Copyright (C) 2019 - 2023  Lev Stipakov <lev@openvpn.net>
#  Copyright (C) 2019 - 2023  Arne Schwabe <arne@openvpn.net>
#

# This file is supposed to be linked from the root of openvpn3-linux
# ln -s contrib/cmake-clion/CMakeLists.txt
# You should still run ./configure to generate a valid config.h before
# utilizing CMake

cmake_minimum_required(VERSION 3.10)
project(openvpn3_linux C CXX)
set(CMAKE_CXX_STANDARD 14)

find_package(PkgConfig REQUIRED)
find_package(Threads REQUIRED)
find_package(OpenSSL REQUIRED)

find_library(UUID uuid)

pkg_check_modules(JSONCPP REQUIRED jsoncpp)
pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)

option(ENABLE_OVPNDCO "Enable OpenVPN data channel offloading")

set(OPENVPN3_LINUX_CONFIG_DEFINES
        -DUSE_OPENSSL
        -DUSE_ASIO
        -DASIO_STANDALONE
        -DOPENVPN_USERNAME="openvpn"
        -DLIBEXECDIR="/usr/libexec"
    )
if (${ENABLE_OVPNDCO})
    list(APPEND OPENVPN3_LINUX_CONFIG_DEFINES -DENABLE_OVPNDCO)
endif()
add_definitions(${OPENVPN3_LINUX_CONFIG_DEFINES})

set(OPENVPN3_LINUX_LIBS
        ${GLIB2_LDFLAGS}
        ${GIO2_LDFLAGS}
        ${CMAKE_THREAD_LIBS_INIT}
        ${OPENSSL_LIBRARIES}
        ${JSONCPP_LIBRARIES}
        ${UUID})

if (${ENABLE_OVPNDCO})
    find_package(PkgConfig)
    pkg_search_module(LIBNL REQUIRED libnl-genl-3.0)
    list(APPEND OPENVPN3_LINUX_LIBS ${LIBNL_LIBRARIES})
endif()

find_package(Protobuf REQUIRED)

link_libraries(${OPENVPN3_LINUX_LIBS})

if(NOT DEFINED OPENVPN3_LINUX_ROOT)
    set(OPENVPN3_LINUX_ROOT ${CMAKE_SOURCE_DIR})
endif()

set(OPENVPN3_LINUX_INCLUDE_DIRS
        ${OPENVPN3_LINUX_ROOT}
        ${OPENVPN3_LINUX_ROOT}/openvpn3-core
        ${OPENVPN3_LINUX_ROOT}/src
        ${GLIB2_INCLUDE_DIRS}
        ${JSONCPP_INCLUDE_DIRS}
        ${OPENVPN3_LINUX_ROOT}/vendor/asio/asio/include)

if (${ENABLE_OVPNDCO})
    find_path(
        LIBNL_INCLUDE_DIR
        PATH_SUFFIXES
            include/libnl3
        NAMES
            netlink/version.h
    )
    list(APPEND OPENVPN3_LINUX_INCLUDE_DIRS
        ${LIBNL_INCLUDE_DIR}
        ${OPENVPN3_LINUX_ROOT}/ovpn-dco/include/uapi
        ${CMAKE_BINARY_DIR}
        ${CMAKE_BINARY_DIR}/src/netcfg # for protobuf generated files
        )
endif()
include_directories(${OPENVPN3_LINUX_INCLUDE_DIRS})

get_directory_property(hasParent PARENT_DIRECTORY)
if(hasParent)
    set(OPENVPN3_LINUX_CONFIG_DEFINES
            ${OPENVPN3_LINUX_CONFIG_DEFINES} PARENT_SCOPE)
    set(OPENVPN3_LINUX_LIBS ${OPENVPN3_LINUX_LIBS} PARENT_SCOPE)
    set(OPENVPN3_LINUX_INCLUDE_DIRS ${OPENVPN3_LINUX_INCLUDE_DIRS} PARENT_SCOPE)
endif()


add_executable(openvpn3-service-client
        src/client/openvpn3-service-client.cpp
        src/client/core-client.hpp
        src/client/core-client-netcfg.hpp
        src/client/backend-signals.hpp
        src/client/statistics.hpp
        src/client/statusevent.hpp
        src/common/core-extensions.hpp
        src/common/cmdargparser.cpp
        src/common/requiresqueue.cpp
        src/common/timestamp.cpp
        src/common/utils.cpp
        src/common/cmdargparser.cpp
        src/common/configfileparser.cpp
        src/configmgr/proxy-configmgr.hpp
        src/configmgr/overrides.cpp
        src/log/dbus-log.hpp
        src/log/proxy-log.hpp
        src/netcfg/proxy-netcfg.hpp
        src/netcfg/proxy-netcfg.cpp
        src/netcfg/dco-keyconfig.proto
        )
protobuf_generate(TARGET openvpn3-service-client)
target_link_libraries(openvpn3-service-client lz4 ${PROTOBUF_LIBRARIES})

add_executable(openvpn3-service-configmgr
        src/configmgr/openvpn3-service-configmgr.cpp
        src/configmgr/configmgr.hpp
        src/configmgr/overrides.cpp
        src/common/cmdargparser.hpp
        src/common/cmdargparser.cpp
        src/common/core-extensions.hpp
        src/common/lookup.cpp
        src/common/timestamp.cpp
        src/common/utils.cpp
        src/common/cmdargparser.cpp
        src/common/configfileparser.cpp
        src/log/dbus-log.hpp
        )

add_executable(openvpn3
        src/ovpn3cli/openvpn3.cpp
        src/ovpn3cli/arghelpers.cpp
        src/ovpn3cli/commands/version.cpp
        src/ovpn3cli/commands/config.cpp
        src/ovpn3cli/commands/session.cpp
        src/ovpn3cli/commands/log.cpp
        src/ovpn3cli/arghelpers.hpp
        src/common/lookup.cpp
        src/common/lookup.hpp
        src/common/cmdargparser.cpp
        src/configmgr/proxy-configmgr.hpp
        src/configmgr/overrides.hpp
        src/configmgr/overrides.cpp
        src/sessionmgr/proxy-sessionmgr.hpp
        src/sessionmgr/sessionmgr-events.hpp
        src/sessionmgr/sessionmgr-events.cpp
        src/dbus/requiresqueue-proxy.hpp
        src/common/cmdargparser.hpp
        src/common/cmdargparser.cpp
        src/common/requiresqueue.cpp
        src/common/timestamp.cpp
        src/common/utils.cpp
        src/common/configfileparser.cpp
        )
target_link_libraries(openvpn3 lz4)

add_executable(openvpn3-service-netcfg
        src/netcfg/openvpn3-service-netcfg.cpp
        src/netcfg/core-tunbuilder.cpp
        src/netcfg/netcfg.hpp
        src/netcfg/netcfg-device.hpp
        src/netcfg/netcfg-dco.hpp
        src/netcfg/netcfg-dco.cpp
        src/netcfg/netcfg-exception.hpp
        src/netcfg/netcfg-options.hpp
        src/netcfg/netcfg-signals.hpp
        src/netcfg/netcfg-changeevent.hpp
        src/netcfg/netcfg-subscriptions.hpp
        src/netcfg/netcfg-subscriptions.cpp
        src/netcfg/dns/resolvconf-file.cpp
        src/netcfg/dns/resolver-settings.cpp
        src/netcfg/dns/settings-manager.cpp
        src/netcfg/dns/systemd-resolved.cpp
        src/netcfg/dns/proxy-systemd-resolved.cpp
        src/netcfg/core-tunbuilder.hpp
        src/common/cmdargparser.cpp
        src/common/lookup.cpp
        src/common/requiresqueue.cpp
        src/common/timestamp.cpp
        src/common/utils.cpp
        src/common/cmdargparser.cpp
        src/common/configfileparser.cpp
        src/log/core-dbus-logbase.hpp
        src/log/dbus-log.hpp
        src/netcfg/netcfg-changeevent.cpp
        src/netcfg/dco-keyconfig.proto
        )

find_library(CAPNG cap-ng)
protobuf_generate(TARGET openvpn3-service-netcfg)
target_link_libraries(openvpn3-service-netcfg ${CAPNG} ${PROTOBUF_LIBRARIES})

add_executable(openvpn3-service-logger
        src/log/openvpn3-service-logger.cpp
        src/log/ansicolours.hpp
        src/log/colourengine.hpp
        src/log/dbus-log.hpp
        src/log/log-helpers.hpp
        src/log/logevent.hpp
        src/log/logger.hpp
        src/log/logwriter.hpp
        src/log/service.hpp
        src/common/timestamp.cpp
        src/common/utils.cpp
        src/common/cmdargparser.cpp
        src/common/configfileparser.cpp
        )

add_executable(openvpn3-service-sessionmgr
        src/sessionmgr/openvpn3-service-sessionmgr.cpp
        src/sessionmgr/sessionmgr.hpp
        src/sessionmgr/sessionmgr-events.hpp
        src/sessionmgr/sessionmgr-events.cpp
        src/client/statusevent.hpp
        src/common/cmdargparser.cpp
        src/common/lookup.cpp
        src/common/requiresqueue.cpp
        src/common/timestamp.cpp
        src/common/utils.cpp
        src/common/cmdargparser.cpp
        src/common/configfileparser.cpp
        src/log/dbus-log.hpp
        )

add_executable(openvpn3-service-backendstart
        src/client/openvpn3-service-backendstart.cpp
        src/client/statusevent.hpp
        src/common/cmdargparser.cpp
        src/common/lookup.cpp
        src/common/requiresqueue.cpp
        src/common/timestamp.cpp
        src/common/utils.cpp
        src/common/cmdargparser.cpp
        src/common/configfileparser.cpp
        src/log/dbus-log.hpp
        )

add_executable(cli-netcfg
        src/tests/netcfg/cli.cpp
        src/netcfg/netcfg.hpp
        src/netcfg/netcfg-device.hpp
        src/netcfg/netcfg-exception.hpp
        src/netcfg/netcfg-options.hpp
        src/netcfg/proxy-netcfg.hpp
        src/netcfg/proxy-netcfg.cpp
        src/netcfg/netcfg-signals.hpp
        src/netcfg/netcfg-changeevent.hpp
        src/netcfg/netcfg-subscriptions.hpp
        src/netcfg/netcfg-subscriptions.cpp
        src/netcfg/core-tunbuilder.hpp
        src/common/lookup.cpp
        src/common/requiresqueue.cpp
        src/common/timestamp.cpp
        src/common/utils.cpp
        src/log/core-dbus-logbase.hpp
        src/log/dbus-log.hpp
        src/netcfg/dco-keyconfig.proto
        )
target_link_libraries(cli-netcfg lz4 ${PROTOBUF_LIBRARIES})
protobuf_generate(TARGET cli-netcfg)

add_subdirectory(addons/aws)

=== openvpn3-core/openvpn/omi/CMakeLists.txt ===
if (NOT WIN32)
  return()
endif()

option(CLI_OVPNDCOWIN "Build ovpncli with ovpn-dco-win driver support" OFF)

add_executable(omicliagent openvpn.cpp)
add_core_dependencies(omicliagent)
add_json_library(omicliagent)
target_compile_definitions(omicliagent PRIVATE -DOPENVPN_COMMAND_AGENT -DOVPNAGENT_DISABLE_PATH_CHECK)

add_executable(omicli openvpn.cpp)
add_core_dependencies(omicli)

if (CLI_OVPNDCOWIN)
  target_compile_definitions(omicliagent PRIVATE ENABLE_OVPNDCOWIN)
  target_compile_definitions(omicli PRIVATE ENABLE_OVPNDCOWIN)
  target_link_libraries(omicliagent "bcrypt.lib")
  target_link_libraries(omicli "bcrypt.lib")
endif ()

=== debian/changelog ===
openvpn3-client (24+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #904044)

 -- Marc Leeman <marc.leeman@gmail.com>  Wed, 12 Feb 2025 20:17:22 +0100

=== debian/control ===
Source: openvpn3-client
Section: net
Priority: optional
Maintainer: Marc Leeman <marc.leeman@gmail.com>
Build-Depends: autoconf,
               autoconf-archive,
               debhelper-compat (= 13),
               dh-python,
               libgdbuspp-dev,
               libasio-dev,
               libcap-ng-dev,
               libdbus-1-dev,
               libglib2.0-dev,
               libjsoncpp-dev,
               liblz4-dev,
               libnl-3-dev,
               libnl-genl-3-dev,
               libprotobuf-dev,
               libprotoc-dev,
               protobuf-compiler,
               libssl-dev,
               systemd-dev | systemd (<< 253-2~),
               libtinyxml2-dev,
               libxml2-utils,
               meson,
               pkgconf,
               polkitd,
               python3,
               python3-dbus,
               python3-docutils,
               python3-jinja2,
               python3-minimal,
               python3-systemd,
               uuid-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://codeberg.org/OpenVPN/openvpn3-linux
Vcs-Git: https://salsa.debian.org/erpel/openvpn3-client.git
Vcs-Browser: https://salsa.debian.org/erpel/openvpn3-client

Package: openvpn3-client
Architecture: any
Depends: ${misc:Depends},
          ${shlibs:Depends},
          ${python3:Depends},
Description: virtual private network client (version 3)
 OpenVPN is an application to securely tunnel IP networks over a
 single UDP or TCP port. It can be used to access remote sites, make
 secure point-to-point connections, enhance wireless security, etc.
 .
 OpenVPN uses all of the encryption, authentication, and certification
 features provided by the OpenSSL library (any cipher, key size, or
 HMAC digest).
 .
 OpenVPN may use static, pre-shared keys or TLS-based dynamic key exchange. It
 also supports VPNs with dynamic endpoints (DHCP or dial-up clients), tunnels
 over NAT or connection-oriented stateful firewalls (such as Linux's iptables).
 .
 This is a new OpenVPN client based on the OpenVPN 3 C++ Core Library.
 The architecture behind this client is completely different from the
 classic OpenVPN 2.x versions, as it enables a strict privilege
 separation as part of the implementation.  In addition, it provides
 possibility to update the DNS configuration when that is being pushed
 from the OpenVPN server.  This client is built around D-Bus which
 enables more advanced ways to interact with OpenVPN tunnels.  And
 it provides an openvpn3 Python 3 module to simplify interaction
 with the client from Python.
 .
 This package contains OpenVPN3 Linux Client

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DEB_BUILD_OPTIONS+=nocheck

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
    -Dopenvpn3_core_version=3 \
    -Dbash-completion=enabled \
    -Dopenvpn_username=_openvpn \
    -Dopenvpn_group=_openvpn \
    -Dasio_path=/usr/ \
    -Dunit_tests=disabled

# dh_ needs to be called in the arch independent build. It is only part
# of the default sequence from compat level 14
override_dh_auto_install:
	dh_installsysusers
	dh_auto_install
	# delete the installed header file, this is not a library
	$(RM) -r $(CURDIR)/debian/openvpn3-client/usr/include
	# allow the directory to be created with tmpfiles.d with the
	# correct owner/permissions
	$(RM) -r $(CURDIR)/debian/openvpn3-client/var/lib/openvpn3/configs

=== debian/watch ===
#https://swupdate.openvpn.net/community/releases/openvpn3-linux-$1.tar.xz"
version=4
opts=" \
  repacksuffix=+dfsg,dversionmangle=s/\+dfsg\d*$//, \
  searchmode=plain, \
  downloadurlmangle=s#.lateststable:(\d+)#-$1.tar.xz#" \
  https://swupdate.openvpn.net/community/releases/openvpn3-linux.latest stable:(\d+)

## openvpn3-client 24.1+dfsg

=== openvpn3-core/client/CMakeLists.txt ===
include(findcoredeps)
include(findswigdeps)

if (BUILD_SWIG_LIB)
    set_property(SOURCE ovpncli.i PROPERTY CPLUSPLUS ON)
    if (NOT MSVC)
        # Swig generates code with deprecated python declarations
        set_property(SOURCE ovpncli.i PROPERTY GENERATED_COMPILE_OPTIONS -Wno-deprecated-declarations -Wno-sometimes-uninitialized -Wno-class-memaccess -Wno-unknown-warning-option)
    endif()

    swig_add_library(ovpnclilib
        TYPE SHARED
        LANGUAGE python
        SOURCES ovpncli.cpp ovpncli.i
        )
    set_property(TARGET ovpnclilib PROPERTY SWIG_COMPILE_DEFINITIONS SWIG_PYTHON_2_UNICODE)
    set_property(TARGET ovpnclilib PROPERTY SWIG_COMPILE_OPTIONS -threads)
    set_property(TARGET ovpnclilib PROPERTY SWIG_INCLUDE_DIRECTORIES ${CORE_DIR})

    add_core_dependencies(ovpnclilib)
    target_link_libraries(ovpnclilib ${Python3_LIBRARIES})
    target_include_directories(ovpnclilib PRIVATE ${Python3_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})

    # Use proper python library name to generate _ovpncli.so/dylib/dll
    set_target_properties(ovpnclilib PROPERTIES OUTPUT_NAME "_ovpncli")
    set_target_properties(ovpnclilib PROPERTIES PREFIX "")

endif ()

=== openvpn3-core/test/ovpncli/CMakeLists.txt ===

option(CLI_NULLTUN "Build ovpncli variant with null tun" OFF)
option(CLI_KOVPN "Build ovpncli variant with kovpn kernel module support" OFF)
option(CLI_OVPNDCO "Build ovpncli with ovpn-dco kernel module support" OFF)
option(CLI_OVPNDCOWIN "Build ovpncli with ovpn-dco-win driver support" OFF)

set(KOVPN_SOURCE "${CORE_DIR}/../kovpn" CACHE PATH "ovpn-dco kernel module source tree")

add_library(
        xkey
        ${CORE_DIR}/openvpn/openssl/xkey/xkey_helper.c
        ${CORE_DIR}/openvpn/openssl/xkey/xkey_provider.c
)

target_compile_definitions(xkey INTERFACE -DENABLE_EXTERNAL_PKI)
add_ssl_library(xkey)


add_executable(ovpncli cli.cpp)
target_compile_definitions(ovpncli PRIVATE)
target_link_libraries(ovpncli xkey)

add_core_dependencies(ovpncli)

if (${CLI_NULLTUN})
    add_executable(ovpnclinull cli.cpp)
    add_core_dependencies(ovpnclinull)
    target_compile_definitions(ovpnclinull PRIVATE -DOPENVPN_FORCE_TUN_NULL)
    target_link_libraries(ovpnclinull xkey)
endif ()

if (${CLI_KOVPN})
    add_executable(ovpnclikovpn cli.cpp)
    add_core_dependencies(ovpnclikovpn)
    target_link_libraries(ovpnclikovpn xkey)

    target_compile_definitions(ovpnclikovpn PRIVATE -DENABLE_KOVPN
      -DOPENVPN_REMOTE_OVERRIDE -DPRIVATE_TUNNEL_PROXY)

    include(kovpn)
    add_kovpn_dependency(ovpnclikovpn)
    target_include_directories(ovpnclikovpn PRIVATE ${KOVPN_SOURCE})

endif()

if (${CLI_OVPNDCO})
    target_compile_definitions(ovpncli PRIVATE -DENABLE_OVPNDCO )

    find_package(PkgConfig)
    pkg_search_module(LIBNL REQUIRED libnl-genl-3.0)

    target_include_directories(ovpncli PRIVATE ${LIBNL_INCLUDE_DIRS})
    target_link_libraries(ovpncli ${LIBNL_LIBRARIES})
endif()

if (WIN32)
    add_executable(ovpncliagent cli.cpp)
    add_core_dependencies(ovpncliagent)
    add_json_library(ovpncliagent)
    target_link_libraries(ovpncliagent xkey)
    target_compile_definitions(ovpncliagent PRIVATE OPENVPN_COMMAND_AGENT
                                                    OVPNAGENT_DISABLE_PATH_CHECK)

    if (${CLI_OVPNDCOWIN})
        target_compile_definitions(ovpncliagent PRIVATE ENABLE_OVPNDCOWIN)
        target_compile_definitions(ovpncli PRIVATE ENABLE_OVPNDCOWIN)
        target_link_libraries(ovpncli "bcrypt.lib")
        target_link_libraries(ovpncliagent "bcrypt.lib")
    endif()
endif ()

if (APPLE)
    add_executable(ovpncliagent cli.cpp)
    target_link_libraries(xkey)
    add_core_dependencies(ovpncliagent)
    add_json_library(ovpncliagent)
    target_compile_definitions(ovpncliagent PRIVATE -DOPENVPN_COMMAND_AGENT)
endif ()

=== openvpn3-core/test/unittests/CMakeLists.txt ===
##
##  Tunable test_proto parameters
##
set(TEST_PROTO_NTHREADS -1 CACHE STRING "test_proto - Override number of threads")
set(TEST_PROTO_RENEG 900 CACHE STRING "test_proto - Renegotiation interval")
set(TEST_PROTO_ITER 1000000 CACHE STRING "test_proto - Number of iterations")
set(TEST_PROTO_SITER 1 CACHE STRING "test_proto - Number of high-level iterations")
set(TEST_KEYCERT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../ssl" CACHE STRING "test_proto - Certificate/private keys for testing")
option(TEST_PROTO_VERBOSE "test/ssl/proto - Enable verbose logging" OFF)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(RUN_UT_AS_ROOT CACHE STRING "Program to use to change to root for running the sitnl tests")
else()
    unset(RUN_UT_AS_ROOT CACHE)
endif()

if (NOT BUILD_TESTING)
  return()
endif()

include(dlgoogletest)

set(CORE_TEST_DEFINES
        -DOPENVPN_FORCE_TUN_NULL
        -DUNIT_TEST
        -DUNITTEST_SOURCE_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/\"
        -DOPENVPN_RC_NOTIFY
        -DOPENVPN_ENABLE_ASSERT
        )

add_executable(coreUnitTests
        core_tests.cpp
        test_acc.cpp
        test_acc_certcheck.cpp
        test_route_emulation.cpp
        test_log.cpp
        test_comp.cpp
        test_b64.cpp
        test_verify_x509_name.cpp
        test_ssl.cpp
        test_sslctx.cpp
        test_continuation.cpp
        test_crypto.cpp
        test_optfilt.cpp
        test_clamp_typerange.cpp
        test_pktstream.cpp
        test_remotelist.cpp
        test_relack.cpp
        test_http_proxy.cpp
        test_peer_fingerprint.cpp
        test_safestr.cpp
        test_numeric_cast.cpp
        test_dns.cpp
        test_header_deps.cpp
        test_capture.cpp
        test_cleanup.cpp
        test_crypto_hashstr.cpp
        test_csum.cpp
        test_format.cpp
        test_headredact.cpp
        test_hostport.cpp
        test_ip.cpp
        test_ostream_containers.cpp
        test_parseargv.cpp
        test_path.cpp
        test_pktid.cpp
        test_prefixlen.cpp
        test_randapi.cpp
        test_rc.cpp
        test_route.cpp
        test_reliable.cpp
        test_splitlines.cpp
        test_statickey.cpp
        test_streq.cpp
        test_time.cpp
        test_typeindex.cpp
        test_tun_builder.cpp
        test_userpass.cpp
        test_validatecreds.cpp
        test_weak.cpp
        test_cliopt.cpp
        test_buffer.cpp
        test_proto.cpp
)

# The compile flags for test_proto.cpp, prefixed with PROTO_ to avoid collision with other defines
if (${TEST_PROTO_VERBOSE})
        set(PROTO_CFLAGS_VERBOSE -DPROTO_VERBOSE)
endif()

target_compile_definitions(coreUnitTests PRIVATE
        ${PROTO_CFLAGS_VERBOSE}
        -DPROTO_N_THREADS=${TEST_PROTO_NTHREADS}
        -DPROTO_RENEG=${TEST_PROTO_RENEG}
        -DPROTO_ITER=${TEST_PROTO_ITER}
        -DPROTO_SITER=${TEST_PROTO_SITER}
        -DTEST_KEYCERT_DIR=\"${TEST_KEYCERT_DIR}/\"
)

if (${USE_MBEDTLS})
    target_sources(coreUnitTests PRIVATE
            test_mbedtls_x509certinfo.cpp
            test_mbedtls_authcert.cpp
            )
else ()
    target_sources(coreUnitTests PRIVATE
            test_openssl_x509certinfo.cpp
            test_openssl_authcert.cpp
            test_opensslpki.cpp
            test_openssl_misc.cpp
            test_session_id.cpp
            )
endif ()

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    target_link_libraries(coreUnitTests cap)
    target_sources(coreUnitTests PRIVATE test_sitnl.cpp)
endif ()

if (UNIX)
    target_sources(coreUnitTests PRIVATE
      # includes <arpa/inet.h>
      test_buffer_ip.cpp

      test_cpu_time.cpp

      # directly includes tempfile.hpp
      test_misc_unix.cpp

      # Uses Unix Pipe semantics
      test_pipe.cpp

      # for now, only for ovpn3 servers (i.e., pgserv)
      test_psid_cookie.cpp
      )
endif ()

if (WIN32)
    target_sources(coreUnitTests PRIVATE test_iphelper.cpp test_wstring.cpp)
endif ()

add_core_dependencies(coreUnitTests)
add_json_library(coreUnitTests)

# xxHash
target_compile_definitions(coreUnitTests PRIVATE -DHAVE_XXHASH)
if(NOT MSVC)
  list(APPEND CMAKE_PREFIX_PATH
    ${DEP_DIR}/xxHash
    ${DEP_DIR}
    )
endif()
find_package(xxHash REQUIRED)
target_link_libraries(coreUnitTests xxHash::xxhash)

find_package(LZO)
if (LZO_FOUND)
  target_compile_definitions(coreUnitTests PRIVATE -DHAVE_LZO)
  target_link_libraries(coreUnitTests lzo::lzo)
  message("lzo found, running lzo compression tests")
else ()
    message("lzo not found, skipping lzo compression tests")
endif ()

target_link_libraries(coreUnitTests ${GTEST_LIB} GTest::gmock ${EXTRA_LIBS})

target_compile_definitions(coreUnitTests PRIVATE ${CORE_TEST_DEFINES})
target_include_directories(coreUnitTests PRIVATE ${EXTRA_INCLUDES})

add_test(NAME CoreTests
    COMMAND ${RUN_UT_AS_ROOT} $<TARGET_FILE:coreUnitTests> --gtest_shuffle --gtest_output=xml:test_results/test_core_$<CONFIG>.xml
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

=== openvpn3-core/openvpn/ovpnagent/win/CMakeLists.txt ===
if (NOT WIN32)
  return()
endif()

add_executable(ovpnagent ovpnagent.cpp)
add_core_dependencies(ovpnagent)
add_json_library(ovpnagent)
target_compile_definitions(ovpnagent PRIVATE -DOVPNAGENT_DISABLE_PATH_CHECK -DOPENVPN_AGENT_START_PROCESS)

=== debian/changelog ===
openvpn3-client (24.1+dfsg-1) unstable; urgency=medium

  [ Marc Leeman ]
  * d/gbp.conf: rename to [import-orig]
  * d/patches: remove access to git with meson
  * d/control: bump Standards-Version to 4.7.2
  * d/copyright: remove unused BSL-1.0
  * d/watch: allow for point releases
  * New upstream version 24.1+dfsg
  * d/patches: refresh
  * Addresses CVE-2025-3908 (Closes: #1106206)

  [ Fabio Pedretti ]
  * d/rules: don't force -Dopenvpn3_core_version=3

 -- Marc Leeman <marc.leeman@gmail.com>  Tue, 20 May 2025 10:36:39 +0200

openvpn3-client (24+dfsg-2) unstable; urgency=medium

  [ Fabio Pedretti ]
  * use proper project page

  [ Marc Leeman ]
  * d/patches: make builds reproduceable (Closes: #1103800)

 -- Marc Leeman <marc.leeman@gmail.com>  Tue, 22 Apr 2025 10:50:56 +0200

## openvpn3-client 25%2Bdfsg

=== openvpn3-core/client/CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,9 @@
 
 if (BUILD_SWIG_LIB)
     set_property(SOURCE ovpncli.i PROPERTY CPLUSPLUS ON)
-    if (NOT MSVC)
+    if (NOT MSVC OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
         # Swig generates code with deprecated python declarations
-        set_property(SOURCE ovpncli.i PROPERTY GENERATED_COMPILE_OPTIONS -Wno-deprecated-declarations -Wno-sometimes-uninitialized -Wno-class-memaccess -Wno-unknown-warning-option)
+        set_property(SOURCE ovpncli.i PROPERTY GENERATED_COMPILE_OPTIONS -Wno-deprecated-declarations -Wno-sometimes-uninitialized -Wno-class-memaccess -Wno-unused-function -Wno-unknown-warning-option)
     endif()
 
     swig_add_library(ovpnclilib

## openvpn3-client 25+dfsg

=== meson_options.txt ===
--- 
+++ 
@@ -102,7 +102,7 @@
        description: 'Override D-Bus system service directory')
 option('systemd_system_unit_dir', type: 'string',
        description: 'Override path to systemd system unit directory')
-option('create_statedir', type: 'boolean', value: 'true',
+option('create_statedir', type: 'boolean', value: true,
        description: 'Create directory for OpenVPN 3 state during install phase')
 
 #

=== openvpn3-core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.30)

project(OpenVPN3-core VERSION 3)

# AddressSanitize - use CXX=clang++ CC=clang cmake -DCMAKE_BUILD_TYPE=asan to build with ASAN
# export  UBSAN_OPTIONS=print_stacktrace=1 helps debugging these
set(CMAKE_C_FLAGS_ASAN
        "-fsanitize=address,undefined -fno-sanitize-recover=all -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1 -DINSTRUMENTATION_SLOWDOWN"
        CACHE STRING "Flags used by the C compiler during AddressSanitizer builds."
        FORCE)
set(CMAKE_CXX_FLAGS_ASAN
        "-fsanitize=address,undefined -fno-sanitize-recover=all -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1 -DINSTRUMENTATION_SLOWDOWN"
        CACHE STRING "Flags used by the C++ compiler during AddressSanitizer builds."
        FORCE)

set(CMAKE_LINKER_FLAGS_ASAN
        "-fsanitize=address,undefined -fno-sanitize-recover=all -fsanitize-address-use-after-scope"
        CACHE STRING "Flags used by the linker during AddressSanitizer builds."
        FORCE)

# Append /MP flag for MSVC
if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake
                      ${CMAKE_MODULE_PATH})
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_C_STANDARD 99)

include(CTest)

include(findcoredeps)
include(ovpn-doxygen)

add_subdirectory(client)
add_subdirectory(test/unittests)
add_subdirectory(test/ovpncli)

add_subdirectory(openvpn/omi)
add_subdirectory(openvpn/ovpnagent/win)
add_subdirectory(openvpn/ovpnagent/mac)

if (ENABLE_DOXYGEN)
    # Exclude some project specific directories
    set(DOXYGEN_EXCLUDE_PATTERNS
        "*/vcpkg_installed/*"
        "*/googletest-src/*"
        "*/rapidcheck-src/*"
        "${PROJECT_SOURCE_DIR}/deps/*"
        "*/test/unittests/comp-testdata/*"
        "*/test/unittests/input/*"
        "*/test/unittests/output/*"
        "*/test/unittests/userpass/*"
        )
    set(DOXYGEN_USE_MDFILE_AS_MAINPAGE "${PROJECT_SOURCE_DIR}/README.md")

    configure_doxygen("OpenVPN 3 Core Library" "core" "doxygen/core")
endif ()

=== openvpn3-core/test/ovpncli/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 option(CLI_KOVPN "Build ovpncli variant with kovpn kernel module support" OFF)
 option(CLI_OVPNDCO "Build ovpncli with ovpn-dco kernel module support" OFF)
 option(CLI_OVPNDCOWIN "Build ovpncli with ovpn-dco-win driver support" OFF)
+option(CLI_TUNBUILDER "Build ovpncli with tunbuilder interface support" OFF)
 
 set(KOVPN_SOURCE "${CORE_DIR}/../kovpn" CACHE PATH "ovpn-dco kernel module source tree")
 
@@ -76,3 +77,7 @@
     add_json_library(ovpncliagent)
     target_compile_definitions(ovpncliagent PRIVATE -DOPENVPN_COMMAND_AGENT)
 endif ()
+
+if (${CLI_TUNBUILDER})
+    target_compile_definitions(ovpncli PRIVATE USE_TUN_BUILDER)
+endif ()

=== openvpn3-core/test/unittests/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,7 @@
 add_executable(coreUnitTests
         core_tests.cpp
         test_acc.cpp
+        test_alignment.cpp
         test_acc_certcheck.cpp
         test_route_emulation.cpp
         test_log.cpp
@@ -40,6 +41,7 @@
         test_ssl.cpp
         test_sslctx.cpp
         test_continuation.cpp
+        test_pushlex.cpp
         test_crypto.cpp
         test_optfilt.cpp
         test_clamp_typerange.cpp
@@ -63,16 +65,19 @@
         test_ostream_containers.cpp
         test_parseargv.cpp
         test_path.cpp
-        test_pktid.cpp
+        test_pktid_control.cpp
+        test_pktid_data.cpp
         test_prefixlen.cpp
         test_randapi.cpp
         test_rc.cpp
         test_route.cpp
         test_reliable.cpp
         test_splitlines.cpp
+        test_loggingmixin.cpp
         test_statickey.cpp
         test_streq.cpp
         test_time.cpp
+        test_make_rc.cpp
         test_typeindex.cpp
         test_tun_builder.cpp
         test_userpass.cpp
@@ -84,18 +89,20 @@
 )
 
 # The compile flags for test_proto.cpp, prefixed with PROTO_ to avoid collision with other defines
+set(PROTO_COMPILE_DEFINITIONS PROTO_N_THREADS=${TEST_PROTO_NTHREADS})
+list(APPEND PROTO_COMPILE_DEFINITIONS PROTO_RENEG=${TEST_PROTO_RENEG})
+list(APPEND PROTO_COMPILE_DEFINITIONS PROTO_ITER=${TEST_PROTO_ITER})
+list(APPEND PROTO_COMPILE_DEFINITIONS TEST_KEYCERT_DIR="${TEST_KEYCERT_DIR}/")
+
 if (${TEST_PROTO_VERBOSE})
-        set(PROTO_CFLAGS_VERBOSE -DPROTO_VERBOSE)
+    list(APPEND PROTO_COMPILE_DEFINITIONS PROTO_VERBOSE)
 endif()
 
-target_compile_definitions(coreUnitTests PRIVATE
-        ${PROTO_CFLAGS_VERBOSE}
-        -DPROTO_N_THREADS=${TEST_PROTO_NTHREADS}
-        -DPROTO_RENEG=${TEST_PROTO_RENEG}
-        -DPROTO_ITER=${TEST_PROTO_ITER}
-        -DPROTO_SITER=${TEST_PROTO_SITER}
-        -DTEST_KEYCERT_DIR=\"${TEST_KEYCERT_DIR}/\"
-)
+# Warning: When defines are only set for one specific test, we need to make sure they do
+# not affect any symbols used by other tests. So be careful before adding more.
+SET_SOURCE_FILES_PROPERTIES(test_proto.cpp PROPERTIES COMPILE_DEFINITIONS
+    "${PROTO_COMPILE_DEFINITIONS}"
+    )
 
 if (${USE_MBEDTLS})
     target_sources(coreUnitTests PRIVATE
@@ -162,7 +169,7 @@
     message("lzo not found, skipping lzo compression tests")
 endif ()
 
-target_link_libraries(coreUnitTests ${GTEST_LIB} GTest::gmock ${EXTRA_LIBS})
+target_link_libraries(coreUnitTests ${GTEST_LIB} GTest::gmock rapidcheck rapidcheck_gtest ${EXTRA_LIBS})
 
 target_compile_definitions(coreUnitTests PRIVATE ${CORE_TEST_DEFINES})
 target_include_directories(coreUnitTests PRIVATE ${EXTRA_INCLUDES})

=== openvpn3-core/deps/vcpkg-ports/asio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(asio)

add_library(asio INTERFACE)

# Export target
install(TARGETS asio
    EXPORT asio
    INCLUDES DESTINATION include/
)

install(EXPORT asio
    DESTINATION "share/asio"
    FILE asio-targets.cmake
)

install(DIRECTORY
    asio/include/asio
    DESTINATION include/
    FILES_MATCHING
        PATTERN "*.hpp"
        PATTERN "*.ipp"
)

install(FILES
    asio/include/asio.hpp
    DESTINATION include/
)

=== openvpn3-core/openvpn/ovpnagent/mac/CMakeLists.txt ===
if (NOT APPLE)
  return()
endif()

add_executable(agent_macos ovpnagent.cpp)
add_core_dependencies(agent_macos)
add_json_library(agent_macos)

# Avoid deprecated warning for using daemon
target_compile_options(agent_macos PRIVATE -Wno-deprecated-declarations)

=== debian/changelog ===
openvpn3-client (25+dfsg-3) unstable; urgency=medium

  * d/patches: add 0005-ovpn_dco_linux-drop-unused-enum-clashing-with-kernel.patch
    (Closes: #1114248)

 -- Marc Leeman <marc.leeman@gmail.com>  Mon, 15 Sep 2025 15:09:16 +0200

openvpn3-client (25+dfsg-2) unstable; urgency=medium

  * trixie has been released, re-upload to unstable

 -- Marc Leeman <marc.leeman@gmail.com>  Mon, 11 Aug 2025 08:36:39 +0200

openvpn3-client (25+dfsg-1) experimental; urgency=medium

  * New upstream version 25+dfsg
  * d/patches: remove upstream applied 0002_fix-openvpn-to-_openvpn.patch
  * d/copyright: remove openvpn3-core/scripts/git-pre-commit-clangformat.sh
  * d/copyright: remove unused BSD-2-Clause

 -- Marc Leeman <marc.leeman@gmail.com>  Fri, 18 Jul 2025 09:38:41 +0200

=== debian/control ===
--- 
+++ 
@@ -32,7 +32,7 @@
                python3-minimal,
                python3-systemd,
                uuid-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://codeberg.org/OpenVPN/openvpn3-linux
 Vcs-Git: https://salsa.debian.org/erpel/openvpn3-client.git

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,6 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-    -Dopenvpn3_core_version=3 \
     -Dbash-completion=enabled \
     -Dopenvpn_username=_openvpn \
     -Dopenvpn_group=_openvpn \

=== debian/watch ===
#https://swupdate.openvpn.net/community/releases/openvpn3-linux-$1.tar.xz"
version=4
opts=" \
  repacksuffix=+dfsg,dversionmangle=s/\+dfsg\d*$//, \
  searchmode=plain, \
  downloadurlmangle=s#.lateststable:([\d\.]+)#-$1.tar.xz#" \
  https://swupdate.openvpn.net/community/releases/openvpn3-linux.latest stable:([\d\.]+)

## openvpn3-client 26+dfsg

=== subprojects/fmt-11.2.0/meson_options.txt ===
option(
    'header-only',
    type: 'boolean',
    value: false,
    description: 'enable header only mode and disable build for libfmt',
)

=== debian/changelog ===
openvpn3-client (26+dfsg-2) unstable; urgency=medium

  * d/control: update Standards-Version to 4.7.3

 -- Marc Leeman <marc.leeman@gmail.com>  Wed, 21 Jan 2026 09:56:48 +0100

openvpn3-client (26+dfsg-1) unstable; urgency=medium

  * New upstream version 26+dfsg
  * Revert "d/patches: add 0005-ovpn_dco_linux-drop-unused-enum-clashing-with-kernel.patch"

 -- Marc Leeman <marc.leeman@gmail.com>  Mon, 19 Jan 2026 08:54:37 +0100

openvpn3-client (25+dfsg-4) unstable; urgency=medium

  * d/rules: enable devposture addon (Closes: #1114001)

 -- Marc Leeman <marc.leeman@gmail.com>  Wed, 14 Jan 2026 16:33:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: openvpn3-client
 Section: net
-Priority: optional
 Maintainer: Marc Leeman <marc.leeman@gmail.com>
 Build-Depends: autoconf,
                autoconf-archive,
@@ -32,7 +31,7 @@
                python3-minimal,
                python3-systemd,
                uuid-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Homepage: https://codeberg.org/OpenVPN/openvpn3-linux
 Vcs-Git: https://salsa.debian.org/erpel/openvpn3-client.git

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,8 @@
     -Dopenvpn_username=_openvpn \
     -Dopenvpn_group=_openvpn \
     -Dasio_path=/usr/ \
-    -Dunit_tests=disabled
+    -Dunit_tests=disabled \
+		-Daddon-deviceposture=enabled
 
 # dh_ needs to be called in the arch independent build. It is only part
 # of the default sequence from compat level 14

## openvpn3-client 27+dfsg

=== meson_options.txt ===
--- 
+++ 
@@ -102,6 +102,8 @@
        description: 'Override D-Bus system service directory')
 option('systemd_system_unit_dir', type: 'string',
        description: 'Override path to systemd system unit directory')
+option('systemd_user_unit_dir', type: 'string',
+       description: 'Override path to systemd user unit directory')
 option('create_statedir', type: 'boolean', value: true,
        description: 'Create directory for OpenVPN 3 state during install phase')

=== debian/changelog ===
openvpn3-client (27+dfsg-1) unstable; urgency=medium

  * d/salsa-ci.yml: add
  * d/copyright: update to include 2026
  * New upstream version 27+dfsg

 -- Marc Leeman <marc.leeman@gmail.com>  Wed, 04 Mar 2026 10:18:05 +0100
